<template>
  <el-select
    v-model="selected"
    class="exam-select"
    :placeholder="placeholder"
    filterable
    :clearable="clearable"
    :disabled="disabled"
    @change="select"
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :value="item.id"
      :label="item.name"
    >
    </el-option>
  </el-select>
</template>

<script>
import { conditionListExam } from "../../modules/base/api";

export default {
  name: "exam-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "考试" },
    value: { type: [Number, String], default: "" },
    clearable: { type: Boolean, default: true },
    semesterId: { type: String, default: "" },
    enable: { type: Boolean, default: null },
    category: { type: String, default: "" },
    defaultSelect: { type: Boolean, default: false },
  },
  data() {
    return {
      optionList: [],
      selected: "",
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      },
    },
    semesterId(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
    category(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
  },
  created() {
    this.search();
  },
  methods: {
    async search() {
      this.optionList = [];
      if (!this.semesterId) return;

      let data = {
        semesterId: this.semesterId,
        category: this.category || undefined,
      };
      if (this.enable !== null) data.enable = this.enable;
      const res = await conditionListExam(data);
      this.optionList = res;
      if (this.defaultSelect && !this.value) this.selectDefault();
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit(
        "change",
        this.optionList.find((item) => item.id === this.selected)
      );
    },
    selectDefault() {
      const defaultData = this.optionList[0];
      if (defaultData) {
        this.selected = defaultData.id;
        this.$emit("input", this.selected);
        this.$emit("change", defaultData);
        this.$emit("default-selected", defaultData);
      }
    },
  },
};
</script>
